*** WeiDU-185/src/arch_mingw.ml	Wed May 18 22:16:00 2005
--- WeiDU/src/arch_mingw.ml	Wed Jan 23 23:01:56 2008
***************
*** 1,3 ****
--- 1,11 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.arch_mingw.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  (* MinGW Arch-Specific Definitions *)
  
  (* Query the Windows Registry to find out about Infinity Engine games. *)
***************
*** 14,37 ****
    (iwd_registry_path ()) ;
    (iwd2_registry_path ()) ;
    (pst_registry_path ()) ; 
!   "C:\\Program Files\\Black Isle\\BGII - SoA\\" 
  ] 
  
  let slash_to_backslash s =
    Str.global_replace (Str.regexp_string "/") "\\\\" s 
  
  (* how to view a text file *)
  let view_command = "start" 
  
  let do_auto_update = true 
  
  (* handle AT_EXIT ~VIEW mydir\myfile.txt~ *)
! let handle_view_command s =
!   let view_regexp = Str.regexp_case_fold "^VIEW" in
!   if Str.string_match view_regexp s 0 then begin
!     let result = Str.replace_first view_regexp view_command s in 
!     result
!   end else s 
  
  external glob : string -> (string -> unit) -> unit = "myglob"
  
--- 22,52 ----
    (iwd_registry_path ()) ;
    (iwd2_registry_path ()) ;
    (pst_registry_path ()) ;
!   "C:\\Program Files\\Black Isle\\BGII - SoA\\" ;
!   "D:\\Program Files\\Black Isle\\BGII - SoA\\" 
  ]
  
  let slash_to_backslash s =
    Str.global_replace (Str.regexp_string "/") "\\\\" s
  
+ let backslash_to_slash (s: string) =
+   s
+ 
  (* how to view a text file *)
  let view_command = "start" 
  
  let do_auto_update = true 
  
  (* handle AT_EXIT ~VIEW mydir\myfile.txt~ *)
! let handle_view_command s skip =
!   let result = ref s in
!   List.iter (fun view_regexp ->
!     if Str.string_match view_regexp !result 0 then begin
!       result := Str.replace_first view_regexp view_command !result ;
!     end) [Str.regexp_case_fold "^NOTEPAD" ; Str.regexp_case_fold "^EXPLORER"; Str.regexp_case_fold "^VIEW"];
!   if skip && (s <> !result) then result := "";
!   let s = !result in
!   s
  
  external glob : string -> (string -> unit) -> unit = "myglob"
  
***************
*** 48,50 ****
--- 63,95 ----
  let biff_path_separator = "\\\\"
  
  let cd_regexp = Str.regexp "^[CH]D[0-9]+.*=\\([^\r\n]*\\)" 
+ 
+ let is_weidu_executable f =
+ 	Str.string_match (Str.regexp_case_fold "setup-.*exe") f 0
+ 
+ 
+ let get_version f =
+ 	let newstdin, newstdin' = Unix.pipe () in
+ 	let newstdout, newstdout' = Unix.pipe () in
+ 	let newstderr, newstderr' = Unix.pipe () in
+ 	let pid = create_process_env
+ 		f [| "WeiDU-Backup" ; "--game bar" |] [| |] newstdin newstdout' newstderr'
+ 	in
+ 	Printf.printf "{%s} Queried (pid = %d)%!" f pid ;
+ 	let ic = Unix.in_channel_of_descr newstdout in
+ 	let line = input_line ic in
+ 	let version =
+ 		try
+ 		let s = Str.global_replace ( Str.regexp_case_fold ".*version \\([0-9]+\\).*") "\\1" line in
+ 		int_of_string s
+ 		with _ -> -1
+ 	in
+ 	(try Unix.close newstdin with _ -> ()) ;
+ 	(try Unix.close newstdout with _ -> ()) ;
+ 	(try Unix.close newstderr with _ -> ()) ;
+ 	(try Unix.close newstdin' with _ -> ()) ;
+ 	(try Unix.close newstdout' with _ -> ()) ;
+ 	(try Unix.close newstderr' with _ -> ()) ;
+ 	let pid', ps = Unix.waitpid [] pid in
+ 	version
+ ;;
