*** WeiDU-185/src/var.ml	Wed May 18 21:42:12 2005
--- WeiDU/src/var.ml	Sun Dec 16 18:52:10 2007
***************
*** 1,3 ****
--- 1,11 ----
+ (* Note added due to LGPL terms.
+ 
+ This file was edited by Valerio Bigiani, AKA The Bigg, starting from
+ 6 November 2005. All changes for this file are listed in
+ diffs/src.var.ml.diff file, as the output of a diff -Bw -c -N command.
+ 
+ It was originally taken from Westley Weimer's WeiDU 185. *)
+ 
  (*
   * TP2 Patch Variables
   *)
***************
*** 10,15 ****
--- 18,27 ----
  
  let variables = Hashtbl.create 255
  
+ let arrays : (string, string list list) Hashtbl.t = Hashtbl.create 255
+ 
+ let cli_variables : string list option ref = ref None
+ 
  let set_int32 name value =
    let name = "%" ^ name ^ "%" in
    (if !debug_assign then Util.log_and_print "SET %s = %ld\n" name value) ; 
***************
*** 25,30 ****
--- 37,56 ----
    (if !debug_assign then Util.log_and_print "SET %s = ~%s~\n" name value) ;
    Hashtbl.replace variables name (String(value))
  
+ let add_local_int32 name value =
+   let name = "%" ^ name ^ "%" in
+   (if !debug_assign then Util.log_and_print "SET %s = %ld\n" name value) ;
+   Hashtbl.add variables name (Int32(value))
+ 
+ let add_local_string name value =
+   let name = "%" ^ name ^ "%" in
+   (if !debug_assign then Util.log_and_print "LOCAL_SET %s = ~%s~\n" name value) ;
+   Hashtbl.add variables name (String(value))
+ 
+ let remove_local name =
+   let name = "%" ^ name ^ "%" in
+   Hashtbl.remove variables name
+ 
  let variable_regexp = Str.regexp "%[^%]+%"
  
  let get_string str =
***************
*** 42,52 ****
    (if !debug_assign then Util.log_and_print "GET ~%s~ = ~%s~\n" str res) ; 
    res
  
  let assoc name value = 
    let value = Int32.of_int value in 
    Hashtbl.replace variables name (Int32 value) 
  
! let _ = 
    assoc "AREA_CITY" 0252 ;
    assoc "AREA_DAY" 0260 ;
    assoc "AREA_DUNGEON" 0256 ;
--- 68,90 ----
    (if !debug_assign then Util.log_and_print "GET ~%s~ = ~%s~\n" str res) ;
    res
  
+ let get_string_exact str =
+   match Hashtbl.find variables str with
+   | Int32(v) -> Int32.to_string v
+   | String(s) -> s
+ 
+ 
+ let clear_var a =
+   let var_spec = Hashtbl.copy variables in
+   Hashtbl.iter ( fun a b -> Hashtbl.remove variables a 
+   ) var_spec ;
+   Hashtbl.clear variables
+ 
  let assoc name value =
    let value = Int32.of_int value in
    Hashtbl.replace variables name (Int32 value)
  
! let all_the_assoc a =
    assoc "AREA_CITY" 0252 ;
    assoc "AREA_DAY" 0260 ;
    assoc "AREA_DUNGEON" 0256 ;
***************
*** 150,152 ****
--- 188,194 ----
  
    ()
  
+ let _ =
+   all_the_assoc () ;
+   ()
+ 
